/* read netphone data and print it with date and time */
/* Version from 30.4.96 */
/* update 1.10 06.08.98 */
/* update 1.11 20.01.99: * event, nochmal 02.02.99/20.-22.02.99 */

/* todo:
   - fuer die eventverarbeitung muessen die events[].condition inhalte ausgewertet
     werden, ausserdem fehlt noch komplett das tracing der meldungen, um zu
     erfassen, ob jetzt grade ein gespraech beendet wurde etc., sprich netphd
     weiss bisher gar nicht den status der nebenstelle ausser einer RING-Erkennung.
*/

/* neu: * event. Bei Nummer=* wird eine Mail mit subject Nummer gesendet */

#include <stdio.h>
#include <string.h>
#include <getopt.h>
#include <time.h>
#include <sys/time.h>
#include <termcap.h>
#include <ctype.h>
#include <signal.h>

#define maxzeile 255
#define GEBFILENAME "/tmp/netphd.geb"
#define logfilename "/var/log/netphone"
#define defcfgfilename "/etc/netphd.cfg"
/* #define logfilename "/home/maik/c/tkisdn/netphd.log" */

#define yes 1
#define no 0
#define maxevents 50 /* braucht 200 KByte Hauptspeicher */

extern time_t get_date ();
static char cfgfilename[230];
FILE *logfile;

struct event_t {
	char number[32];
	int app;
	int condition;
	char scall[4056];
} events[maxevents];

static int anzevents;

static const char *form = "%b %d %H:%M:%S";
static char *zeit = NULL;
static int timediff;
static time_t when;
static size_t maxlen = 229;
static struct tm *convtime;
static time_t actual;


void killhup()
{
	anzevents=0;
	readcfgfile();
	signal(SIGHUP, killhup);
}


void killterm()
{
	fclose(logfile);
	exit(1);
}


readcfgfile()
{
	FILE *cfgf;
	char *rest, *fileread;
	char cfgin[255];
	int countspaces = 2;
	
	if((cfgf=fopen(cfgfilename, "r"))!=NULL)
		while((fileread=fgets(cfgin, sizeof(cfgin), cfgf))!=NULL) {
			sscanf(cfgin, "%s %d", events[anzevents].number, &events[anzevents].app);
			events[anzevents].condition = events[anzevents].app / 10;
			events[anzevents].app = events[anzevents].app % 10;
			rest = cfgin;
			while(countspaces > 0)
				if(*rest++ == ' ') --countspaces;
			countspaces = 2;
			strncpy(events[anzevents].scall, rest, strlen(rest)-1);
			events[anzevents++].scall[strlen(rest)-1]='\0';
		}
}


main()
{
	char zeile[maxzeile], *zeit, inpline[255];
	const char *form;
	time_t when;
	size_t maxlen = 229;
	struct tm *convtime;
	int i, ldowncount;
	FILE *gebfile;
	
	form = "%b %d %H:%M:%S";
	zeit = NULL;
	
	strcpy(cfgfilename, defcfgfilename);
	anzevents = 0;
	readcfgfile();
	
	logfile = fopen(logfilename, "a");
	signal(SIGTERM, killterm);
	signal(SIGHUP, killhup);
	ldowncount = 0;
	while(1) {
		fgets(zeile, sizeof(zeile), stdin);
		if (zeile[0] == 0x0d)
			for(i=0; i<strlen (zeile); i++)
				zeile[i]=zeile[i+1];
		while (zeile[strlen(zeile)-1] == '\n') 
			zeile[strlen(zeile)-1] = '\0';
		/* Gebuehrenspeicherausgabe in Datei */
		if(!strncmp(zeile, "Gebuehrensummen", 15)) {
			gebfile = fopen(GEBFILENAME, "w");
			fprintf(gebfile, "%s\n", zeile);
			do {
				fgets(zeile, sizeof(zeile), stdin);
				while (zeile[strlen(zeile)-1] == '\n') 
					zeile[strlen(zeile)-1] = '\0';
				if (zeile[0] == 0x0d)
					/* for(i=0; i<maxzeile; i++) */
					for(i=0; i < strlen (zeile); i++)
						zeile[i]=zeile[i+1];
				fprintf(gebfile, "%s\n", zeile);
			} while(strncmp(zeile, "Summe :", 7));
			fclose(gebfile);
		} else {
			if (strncmp(zeile, "App ", 4)) { /* normale event-Zeile */
				time(&when);
				convtime = localtime (&when);
				zeit = (char *)realloc(zeit, maxlen);
				strftime(zeit, maxlen, form, convtime);
				if (!strncmp(zeile, "L2Down", 6)) {
					ldowncount++;
					if (ldowncount == 1)
						fprintf(logfile, "%s  %s\n", zeit, zeile);
				} else
					switch (ldowncount) {
						case 0:	fprintf(logfile, "%s  %s\n", zeit, zeile);
							break;
						case 1:	ldowncount = 0;
							fprintf(logfile, "%s  %s\n", zeit, zeile);
							break;
						default: fprintf(logfile, "%s  Last message repeated %d times\n", zeit, ldowncount);
							ldowncount = 0;
							fprintf(logfile, "%s  %s\n", zeit, zeile);
						}
				sprintf(inpline, "%s  %s\n", zeit, zeile);
				checkevent(inpline, zeit);
			} else { /* Gespraechsendegebuehren */
				if (ldowncount > 1) {
					time(&when);
					convtime = localtime (&when);
					zeit = (char *)realloc(zeit, maxlen);
					strftime(zeit, maxlen, form, convtime);
					fprintf(logfile, "%s  Last message repeated %d times\n", zeit, ldowncount);
				}
				fprintf(logfile, "%s\n", zeile);
				ldowncount = 0;
			}
			fflush(logfile);
		}
	}
	fclose(logfile);
}


void reverse(char s[])
{
	int c, i, j;
	
	for (i=0, j = strlen(s)-1; i < j; i++, j--) {
		c = s[i];
		s[i] = s[j];
		s[j] = c;
	}
}


void itoa(char s[], int n)
{
	int i, sign;
	
	if ((sign = n) < 0)
		n = -n;
	i = 0;
	do {
		s[i++] = n % 10 + '0';
	} while ((n /= 10) > 0);
	if (sign < 0)
		s[i++] = '-';
	s[i] = '\0';
	reverse(s);
}


checkevent(char inpline[], char *zeit)
{
	char callingnr[25], datestr[15];
	char command[35];
	char lngs[1024];
	char apptonotify[16], tstr[16], mailnot[255];
	unsigned int app, i, j, seconds;
	
	apptonotify[0]='\0';
	mailnot[0]='\0';
	if(strncmp(inpline, "App ", 4) && (inpline[17] != 'L')) {
		strncpy(datestr, inpline, 15);
		datestr[15]='\0';
		for(i=18, j=0; inpline[i]!='@'; i++,j++)
			command[j] = inpline[i];
		command[j] = '\0';
		app = inpline[++i] - 48;
		if(!strncmp(command, "RING", 4)) {
			if(strlen(command)>4) {
			  sscanf(command, "RING%s", callingnr);
			} else {
			  strcpy(callingnr, "unknown");
			}
			for(j=0;j<anzevents;j++) { /* Eventverarbeitung */
			  if (!strcmp(callingnr, events[j].number) && (app == events[j].app)) {
			    system(events[j].scall);
			  }
			  if(!strcmp(events[j].number, "*") && (app == events[j].app) && strcmp(callingnr,"END")) {
			    if(strlen(apptonotify)==0) {
			      itoa(apptonotify, app);
			    } else {
			      strcat(apptonotify, "+");
			      itoa(tstr, app);
			      strcat(apptonotify, tstr);
			    }
			    strcpy(mailnot, events[j].scall);
			  }
			}
			if(strlen(apptonotify)>0) {
			  sprintf(lngs, "/usr/local/bin/notifyhandy %s %s %s '%s'", mailnot, apptonotify, callingnr, zeit);
			  system(lngs);
			}
		}
/*
		if(!strcmp(command, "AMT ONHOOK") && (app == 4)) {
			system("soonpppoff");
		}
*/
	}
}

/* --------- EOF --------- */
